<?php


declare(strict_types=1);

namespace FiloBlu\Refilo\Test\Unit\Heler;

use FiloBlu\Refilo\Helper\Indexer;
use Magento\Framework\App\ResourceConnection;
use PHPUnit\Framework\TestCase;

/**
 * Class IndexerTest
 * @package FiloBlu\Refilo\Test\Unit\Heler
 */
class IndexerTest extends TestCase
{

    /**
     * @dataProvider getIntervals
     * @param $intervals
     * @param $expect
     */
    public function testGetDeletedEntityIds($intervals, $expect)
    {
        $resourceConnection = $this->createMock(ResourceConnection::class);

        $helper = new Indexer($resourceConnection);
        $result = $helper->getDeletedEntityIdsByIntervals($intervals);

        sort($result);
        sort($expect);
        static::assertEquals($result, $expect);
    }

    /**
     * @return array[]
     */
    public function getIntervals()
    {
        return [
            [
                [
                    ['start' => 1, 'end' => 859],
                    ['start' => 861, 'end' => 1100],
                    ['start' => 1109, 'end' => 1129]
                ], [860, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108]
            ]
        ];

    }

    protected function setUp(): void
    {
    }

    protected function tearDown(): void
    {
    }
}
